- Qt 6.4
- Qt Quick 3D Physics
- QML Types
- DynamicsWorld
- Qt Quick 3D Physics | Commercial or GPLv3

# DynamicsWorld QML Type

The dynamics world. More...

Import Statement: | import QtQuick3DPhysics
Since: | Qt 6.4

- List of all members, including inherited members

## Properties

- defaultDensity : float
- enableCCD : bool
- forceDebugView : bool
- gravity : vector3d
- maxTimestep : float
- minTimestep : float
- running : bool
- sceneView : View3D
- typicalLength : float
- typicalSpeed : float

## Detailed Description

This is the dynamics world. This node is used to create an instance of the physics world as well as define its properties. There can only be one dynamics world. All collision nodes in the qml will get added automatically to the dynamics world.

## Property Documentation

defaultDensity : float

This property defines the default density of dynamic objects, measured in kilograms per cubic unit. This is equal to the weight of a cube with side `1`.

The default value is `0.001`, corresponding to 1 g/cm³: the density of water. If your unit of measurement is meters, a good value would be `1000`. Note that only positive values are allowed.

enableCCD : bool

This property enables continuous collision detection. This will reduce the risk of bodies going through other bodies at high velocities (also known as tunnelling). The default value is `false`.

forceDebugView : bool

This property enables debug drawing of all active shapes in the physics world. The default value is `false`.

gravity : vector3d

This property defines the gravity vector of the physics world. The default value is `(0, -981, 0)`. Set the value to `Qt.vector3d(0, -9.81, 0)` if your unit of measurement is meters and you are simulating Earth gravity.

maxTimestep : float

This property defines the maximum simulation timestep in milliseconds. The default value is `33.333` which corresponds to `30` frames per second.

minTimestep : float

This property defines the minimum simulation timestep in milliseconds. The default value is `16.667` which corresponds to `60` frames per second.

running : bool

This property starts or stops the physical simulation. The default value is `true`.

sceneView : View3D

This property defines the viewport of the scene. If unset when the physical simulation is started a View3D will try to be located among the parents of this world. The first and top-most View3D found in any of this world's parents will be used.

typicalLength : float

This property defines the approximate size of objects in the simulation. This is used to estimate certain length-related tolerances. Objects much smaller or much larger than this size may not behave properly. The default value is `100`.

typicalSpeed : float

This property defines the typical magnitude of velocities of objects in simulation. This is used to estimate whether a contact should be treated as bouncing or resting based on its impact velocity, and a kinetic energy threshold below which the simulation may put objects to sleep.

For normal physical environments, a good choice is the approximate speed of an object falling under gravity for one second. The default value is `1000`.